Bug 853378 - Review Request: perl-Log-Dispatch-Configurator-Any - Configurator implementation with Config::Any
Review Request: perl-Log-Dispatch-Configurator-Any - Configurator implementat...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jitka Plesnikova
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 853379
  Show dependency treegraph
 
Reported: 2012-08-31 05:59 EDT by Simone Caronni
Modified: 2012-09-23 14:28 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-09-17 13:44:27 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jplesnik: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Simone Caronni 2012-08-31 05:59:08 EDT
Spec URL: http://slaanesh.fedorapeople.org/perl-Log-Dispatch-Configurator-Any.spec
SRPM URL: http://slaanesh.fedorapeople.org/perl-Log-Dispatch-Configurator-Any-1.110690-1.fc17.src.rpm
Description: Log::Dispatch::Config is a wrapper for Log::Dispatch and provides a way to
configure Log::Dispatch objects with configuration files. Somewhat like a lite
version of log4j and Log::Log4perl it allows multiple log destinations.
The standard configuration file format for Log::Dispatch::Config is AppConfig.

This module plugs in to Log::Dispatch::Config and allows the use of other file
formats, in fact any format supported by the Config::Any module. As a bonus you
can also pass in a configuration data structure instead of a file name.
Fedora Account System Username: slaanesh
Comment 1 Jitka Plesnikova 2012-09-03 09:40:06 EDT
Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated

==== Generic ====
[x]: EXTRA Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: EXTRA Spec file according to URL is the same as in SRPM.
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Sources contain only permissible code or content.
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files section. This is OK if packaging
     for EPEL5. Otherwise not needed
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[-]: MUST Package contains desktop file if it is a GUI application.
[-]: MUST Development files must be in a -devel package
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[-]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[!]: MUST Package complies to the Packaging Guidelines
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
[-]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
[x]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: MUST Package is named using only allowed ascii characters.
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Package is not relocatable.
[ ]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[x]: SHOULD Reviewer should test that the package builds in mock.
[!]: SHOULD Buildroot is not present
     Note: Buildroot is not needed unless packager plans to package for EPEL5
[!]: SHOULD Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL5
[x]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[-]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[?]: SHOULD Package functions as described.
[x]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[x]: SHOULD SourceX / PatchY prefixed with %{name}.
     Note: Source0 (Log-Dispatch-Configurator-Any-1.110690.tar.gz)
[x]: SHOULD SourceX is a working URL.
[-]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[!]: SHOULD %check is present and all tests pass.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Rpmlint
-------
Checking: perl-Log-Dispatch-Configurator-Any-1.110690-1.fc16.src.rpm
          perl-Log-Dispatch-Configurator-Any-1.110690-1.fc16.noarch.rpm
perl-Log-Dispatch-Configurator-Any.src: W: spelling-error %description -l en_US Config -> Con fig, Con-fig, Configure
perl-Log-Dispatch-Configurator-Any.src: W: non-standard-group Applications/CPAN
perl-Log-Dispatch-Configurator-Any.src:31: W: setup-not-quiet
perl-Log-Dispatch-Configurator-Any.src: W: invalid-url Source0: http://www.cpan.org/modules/by-module/Net/Log-Dispatch-Configurator-Any-1.110690.tar.gz HTTP Error 404: Not Found
perl-Log-Dispatch-Configurator-Any.noarch: W: spelling-error %description -l en_US Config -> Con fig, Con-fig, Configure
perl-Log-Dispatch-Configurator-Any.noarch: W: non-standard-group Applications/CPAN
perl-Log-Dispatch-Configurator-Any.noarch: W: manifest-in-perl-module /usr/share/doc/perl-Log-Dispatch-Configurator-Any-1.110690/MANIFEST
perl-Log-Dispatch-Configurator-Any.noarch: E: incorrect-fsf-address /usr/share/doc/perl-Log-Dispatch-Configurator-Any-1.110690/LICENSE
2 packages and 0 specfiles checked; 1 errors, 7 warnings.

ISSUES:
* Invalid source URL. It should be
http://search.cpan.org/CPAN/authors/id/O/OL/OLIVER/%{perlname}-%{version}.tar.gz
* Missing BuildRequires:
  perl(base) - lib/Log/Dispatch/Configurator/Any.pm:9
  perl(Carp) - lib/Log/Dispatch/Configurator/Any.pm:11
  perl(Config::Any) >= 0.15 - lib/Log/Dispatch/Configurator/Any.pm:10
  pelr(Log::Dispatch::Config)- t/20-file.t:4
  perl(Log::Dispatch::Configurator) - lib/Log/Dispatch/Configurator/Any.pm:9
  perl(Test::More) - all tests in t/
* Optional BuildRequires for tests:
  perl(Config::Tiny) - t/21-not-hashref-in-file.t:8
  perl(Test::Pod) >= 1.14 - t/pod.t:4
  perl(Test::Pod::Coverage) >= 1.04 - t/pod-coverage.t:4
  perl(YAML::Tiny) - t/20-file.t:8
* Missing Requires (listed in META.yml):
  perl(Config::Any) >= 0.15
  perl(Log::Dispatch) >= 2.23 - there could be problem with EPEL 5. It
  contains 2.20.
* Group should be Development/Libraries
* %check is missing. Please add
  %check
  make test
* Please remove README (it is same as man page), MANIFEST and META.yml from %docs
* Add the option "-q" to %setup
* Add "%{_fixperms} $RPM_BUILD_ROOT/*" at the end of %install section.

It is not issue, if you want to build it for EPEL 5:
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files section. This is OK if packaging
     for EPEL5. Otherwise not needed
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
[!]: SHOULD Buildroot is not present
     Note: Buildroot is not needed unless packager plans to package for EPEL5
[!]: SHOULD Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL5


Because you want to build the rpm also for EPEL 5, please fix all issue
which are not related to EPEL 5.

Package is NOT approved.



Generated by fedora-review 0.2.0 (53cc903) last change: 2012-07-09
Comment 2 Jitka Plesnikova 2012-09-03 09:47:47 EDT
You can use cpanspec to generate a spec file for a CPAN module. The created spec file will contains valid URL, group, correct setup option, check section and EPEL5 stuff.
Comment 3 Simone Caronni 2012-09-03 10:41:59 EDT
Woah. So many errors. Thanks for your review.

I didn't know about cpanspec, I regenerated the spec file with it and added the changes regarding the errors you pointed out.

I left the EPEL 5 stuff in and I will ask the perl-Log-Dispatch mantainer if the latest Log::Dispatch can also be built for EPEL 5. It if it's not, I will not push anything to the el5 branch.

$ rpmlint perl-Log-Dispatch-Configurator-Any.spec
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

These are the things I've not fixed yet:

* Missing BuildRequires: perl(base)

  Is this really needed?
  cpanspec does not add it and is pulled in by other modules.

* Optional BuildRequires for tests:
  perl(Test::Pod) >= 1.14 and perl(Test::Pod::Coverage) >= 1.04

  Should I add those? They are both in EPEL but cpanspec does not have added them.

Spec URL: http://slaanesh.fedorapeople.org/perl-Log-Dispatch-Configurator-Any.spec
SRPM URL: http://slaanesh.fedorapeople.org/perl-Log-Dispatch-Configurator-Any-1.110690-2.fc17.src.rpm
Comment 4 Jitka Plesnikova 2012-09-03 11:04:28 EDT
cpanspec add only dependencies mentioned in META.*, there could miss some dependencies.

For finding the requirement, I am going though the content of the source tarball. 
I am looking for modules which are loaded by 'use' or 'require' for tests and also module from lib/ which are used for the tests.
I add to BR each modules which could be packed separately from CPAN (http://search.cpan.org/~rgarcia/base-2.18/).

The optional BRs are not necessary, the tests will pass without them. You don't have to add them. It's up to you.
Comment 5 Simone Caronni 2012-09-03 11:10:59 EDT
Thanks for the explanation! Here is the updated one with added perl-Test-Pod* requirements for tests. I've left perl(base) out.

Spec URL: http://slaanesh.fedorapeople.org/perl-Log-Dispatch-Configurator-Any.spec
SRPM URL: http://slaanesh.fedorapeople.org/perl-Log-Dispatch-Configurator-Any-1.110690-3.fc17.src.rpm
Comment 6 Simone Caronni 2012-09-03 11:39:56 EDT
No, it cannot be built on EPEL 5. As you pointed out it depends on Log::Dispatcher 2.23; which in turn depends on Log::Syslog 0.16 which is provided by perl itself but in later revisions so I cannot ask for a build on the el5 branch.

I've stripped out EPEL 5 stuff from this and the dependent packages:

Spec URL: http://slaanesh.fedorapeople.org/perl-Log-Dispatch-Configurator-Any.spec
SRPM URL: http://slaanesh.fedorapeople.org/perl-Log-Dispatch-Configurator-Any-1.110690-4.fc17.src.rpm

Thanks,
--Simone
Comment 7 Jitka Plesnikova 2012-09-03 12:08:41 EDT
There is missing following Requires.
Requires: perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

Each perl module have to have it. It defined the version of perl which was used for build. The version should be installed in the system.


rpm -qp --requires /var/lib/mock/fedora-rawhide-x86_64/result/perl-Log-Dispatch-Configurator-Any-1.110690-3.fc19.noarch.rpm | uniq -c
      2 perl(Carp)  
      1 perl(Config::Any)  
      1 perl(Config::Any) >= 0.15
      1 perl(Log::Dispatch) >= 2.23
      2 perl(Log::Dispatch::Configurator)  
      1 perl(base)  
      1 perl(strict)  
      1 perl(warnings)  
      1 rpmlib(CompressedFileNames) <= 3.0.4-1
      1 rpmlib(FileDigests) <= 4.6.0-1
      1 rpmlib(PayloadFilesHavePrefix) <= 4.0-1
      1 rpmlib(PayloadIsXz) <= 5.2-1

perl(Carp), perl(Log::Dispatch::Configurator) don't need to be mention in Requires.
Comment 8 Simone Caronni 2012-09-03 12:28:13 EDT
Updated; added perl module compat, removed Carp and Log::Dispatch::Configurator from Requires:

Spec URL: http://slaanesh.fedorapeople.org/perl-Log-Dispatch-Configurator-Any.spec
SRPM URL: http://slaanesh.fedorapeople.org/perl-Log-Dispatch-Configurator-Any-1.110690-5.fc17.src.rpm
Comment 9 Jitka Plesnikova 2012-09-04 02:14:10 EDT
Package APPROVED.
Comment 10 Simone Caronni 2012-09-04 02:49:24 EDT
New Package SCM Request
=======================
Package Name: perl-Log-Dispatch-Configurator-Any
Short Description: Configurator implementation with Config::Any
Owners: slaanesh
Branches: f16 f17 f18 el6
InitialCC:
Comment 11 Simone Caronni 2012-09-04 03:00:39 EDT
Thanks for the review. I've fixed all the errors you pointed out in this review also on the 2 other packages.
Comment 12 Gwyn Ciesla 2012-09-04 06:03:34 EDT
Git done (by process-git-requests).
Comment 13 Fedora Update System 2012-09-04 10:57:57 EDT
perl-Log-Dispatch-Configurator-Any-1.110690-5.fc16,perl-Net-Appliance-Session-3.122100-2.fc16,perl-Net-CLI-Interact-1.122100-2.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/perl-Log-Dispatch-Configurator-Any-1.110690-5.fc16,perl-Net-Appliance-Session-3.122100-2.fc16,perl-Net-CLI-Interact-1.122100-2.fc16
Comment 14 Fedora Update System 2012-09-04 10:58:36 EDT
perl-Log-Dispatch-Configurator-Any-1.110690-5.fc17,perl-Net-Appliance-Session-3.122100-2.fc17,perl-Net-CLI-Interact-1.122100-2.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/perl-Log-Dispatch-Configurator-Any-1.110690-5.fc17,perl-Net-Appliance-Session-3.122100-2.fc17,perl-Net-CLI-Interact-1.122100-2.fc17
Comment 15 Fedora Update System 2012-09-04 10:59:13 EDT
perl-Log-Dispatch-Configurator-Any-1.110690-5.fc18,perl-Net-Appliance-Session-3.122100-2.fc18,perl-Net-CLI-Interact-1.122100-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/perl-Log-Dispatch-Configurator-Any-1.110690-5.fc18,perl-Net-Appliance-Session-3.122100-2.fc18,perl-Net-CLI-Interact-1.122100-2.fc18
Comment 16 Fedora Update System 2012-09-04 11:02:42 EDT
perl-Log-Dispatch-Configurator-Any-1.110690-5.el6,perl-Net-Appliance-Session-3.122100-2.el6,perl-Net-CLI-Interact-1.122100-2.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/perl-Log-Dispatch-Configurator-Any-1.110690-5.el6,perl-Net-Appliance-Session-3.122100-2.el6,perl-Net-CLI-Interact-1.122100-2.el6
Comment 17 Fedora Update System 2012-09-04 12:54:02 EDT
perl-Log-Dispatch-Configurator-Any-1.110690-5.fc18, perl-Net-Appliance-Session-3.122100-2.fc18, perl-Net-CLI-Interact-1.122100-2.fc18 has been pushed to the Fedora 18 testing repository.
Comment 18 Fedora Update System 2012-09-17 13:44:27 EDT
perl-Log-Dispatch-Configurator-Any-1.110690-5.fc17, perl-Net-Appliance-Session-3.122100-2.fc17, perl-Net-CLI-Interact-1.122100-2.fc17 has been pushed to the Fedora 17 stable repository.
Comment 19 Fedora Update System 2012-09-17 14:02:41 EDT
perl-Log-Dispatch-Configurator-Any-1.110690-5.fc16, perl-Net-Appliance-Session-3.122100-2.fc16, perl-Net-CLI-Interact-1.122100-2.fc16 has been pushed to the Fedora 16 stable repository.
Comment 20 Fedora Update System 2012-09-17 18:47:59 EDT
perl-Log-Dispatch-Configurator-Any-1.110690-5.fc18, perl-Net-Appliance-Session-3.122100-2.fc18, perl-Net-CLI-Interact-1.122100-2.fc18 has been pushed to the Fedora 18 stable repository.
Comment 21 Fedora Update System 2012-09-23 14:28:37 EDT
perl-Log-Dispatch-Configurator-Any-1.110690-5.el6, perl-Net-Appliance-Session-3.122100-2.el6, perl-Net-CLI-Interact-1.122100-2.el6 has been pushed to the Fedora EPEL 6 stable repository.

Note You need to log in before you can comment on or make changes to this bug.